name: CS

on:
  # Run on all pushes and on all pull requests.
  # Prevent the build from running when there are only irrelevant changes.
  push:
  pull_request:
  # Allow manually triggering the workflow.
  workflow_dispatch:

# Cancels all previous workflow runs for the same branch that have not yet completed.
concurrency:
  # The concurrency group contains the workflow name and the branch name.
  group: ${{ github.workflow }}-${{ github.ref }}
  cancel-in-progress: true

jobs:
  checkcs:
    name: 'Basic CS and QA checks'
    runs-on: ubuntu-latest

    env:
      XMLLINT_INDENT: '    '
      # - COMPOSER_ROOT_VERSION is needed to get round the recursive dependency when using CI.
      COMPOSER_ROOT_VERSION: '1.99.99'

    steps:
      - name: Checkout code
        uses: actions/checkout@08c6903cd8c0fde910a37f88322edcfb5dd907a8 # v5.0.0
        with:
          persist-credentials: false

      - name: Install PHP
        uses: shivammathur/setup-php@bf6b4fbd49ca58e4608c9c89fba0b8d90bd2a39f # 2.35.5
        with:
          php-version: 'latest'
          coverage: none
          tools: cs2pr

      # Validate the composer.json file.
      # @link https://getcomposer.org/doc/03-cli.md#validate
      - name: Validate Composer installation
        run: composer validate --no-check-all --strict

      - name: 'Composer: adjust dependencies'
        run: |
          # The sniff stage doesn't run the unit tests, so no need for PHPUnit.
          composer remove --no-update --dev phpunit/phpunit --no-scripts
          # Using PHPCS `4.x` as an early detection system for bugs upstream.
          composer require --no-update squizlabs/php_codesniffer:"4.x-dev"

      # Install dependencies and handle caching in one go.
      # @link https://github.com/marketplace/actions/install-php-dependencies-with-composer
      - name: Install Composer dependencies
        uses: "ramsey/composer-install@3cf229dc2919194e9e36783941438d17239e8520" # 3.1.1
        with:
          # Bust the cache at least once a month - output format: YYYY-MM.
          custom-cache-suffix: $(date -u "+%Y-%m")

      # Validate the XML files.
      - name: Validate ruleset XML against schema
        uses: phpcsstandards/xmllint-validate@0fd9c4a9046055f621fca4bbdccb8eab1fd59fdc # v1.0.1
        with:
          pattern: "./*/ruleset.xml"
          xsd-file: "vendor/squizlabs/php_codesniffer/phpcs.xsd"

      - name: Validate Project PHPCS ruleset against schema
        uses: phpcsstandards/xmllint-validate@0fd9c4a9046055f621fca4bbdccb8eab1fd59fdc # v1.0.1
        with:
          pattern: "phpcs.xml.dist"
          xsd-file: "vendor/squizlabs/php_codesniffer/phpcs.xsd"

      - name: "Validate PHPUnit < 10 config for use with PHPUnit 8"
        uses: phpcsstandards/xmllint-validate@0fd9c4a9046055f621fca4bbdccb8eab1fd59fdc # v1.0.1
        with:
          pattern: "phpunit.xml.dist"
          xsd-file: "vendor/phpunit/phpunit/schema/8.5.xsd"

      - name: "Validate PHPUnit < 10 config for use with PHPUnit 9"
        uses: phpcsstandards/xmllint-validate@0fd9c4a9046055f621fca4bbdccb8eab1fd59fdc # v1.0.1
        with:
          pattern: "phpunit.xml.dist"
          xsd-file: "vendor/phpunit/phpunit/schema/9.2.xsd"

      - name: "Validate PHPUnit 10+ config for use with PHPUnit 10"
        uses: phpcsstandards/xmllint-validate@0fd9c4a9046055f621fca4bbdccb8eab1fd59fdc # v1.0.1
        with:
          pattern: "phpunit10.xml.dist"
          xsd-file: "vendor/phpunit/phpunit/schema/10.5.xsd"

      - name: "Validate PHPUnit 10+ config for use with PHPUnit 11"
        uses: phpcsstandards/xmllint-validate@0fd9c4a9046055f621fca4bbdccb8eab1fd59fdc # v1.0.1
        with:
          pattern: "phpunit10.xml.dist"
          xsd-file: "vendor/phpunit/phpunit/phpunit.xsd"

      # Check the code-style consistency of the XML file.
      # Note: this needs xmllint, but that will be installed via the phpcsstandards/xmllint-validate action runner.
      - name: Check XML code style
        run: diff -B ./PHPCSUtils/ruleset.xml <(xmllint --format "./PHPCSUtils/ruleset.xml")

      # Check the code-style consistency of the PHP files.
      - name: Check PHP code style
        id: phpcs
        run: vendor/bin/phpcs --report-full --report-checkstyle=./phpcs-report.xml

      - name: Show PHPCS results in PR
        if: ${{ always() && steps.phpcs.outcome == 'failure' }}
        run: cs2pr ./phpcs-report.xml

  phpstan:
    name: "PHPStan"
    uses: PHPCSStandards/.github/.github/workflows/reusable-phpstan.yml@main
    with:
      phpstanVersion: '2.x'

  markdownlint:
    name: 'Lint Markdown'
    uses: PHPCSStandards/.github/.github/workflows/reusable-markdownlint.yml@main

  remark:
    name: 'QA Markdown'
    uses: PHPCSStandards/.github/.github/workflows/reusable-remark.yml@main

  yamllint:
    name: 'Lint Yaml'
    uses: PHPCSStandards/.github/.github/workflows/reusable-yamllint.yml@main
    with:
      strict: true
